=== debian/changelog ===
readsb (3.14.1630+git20240609.adc080d-1) unstable; urgency=medium

  * New upstream release.
  * debian/readsb.postrm: don't error out when deluser is missing
  * add patch to make package reproducible build (Closes: #1085283)
    Thanks a lot to Chris Lamb for the patch.

 -- Thorsten Alteholz <debian@alteholz.de>  Thu, 17 Oct 2024 22:53:06 +0200

readsb (3.14.1630-1) unstable; urgency=medium

  * first upload

 -- Thorsten Alteholz <debian@alteholz.de>  Sun, 13 Oct 2024 22:03:02 +0200
