=== debian/control ===
Source: readsb
Section: net
Priority: optional
Maintainer: Thorsten Alteholz <debian@alteholz.de>
Build-Depends: debhelper-compat(=13)
	, libusb-1.0-0-dev
	, libncurses-dev
	, zlib1g-dev
	, zlib1g
	, pkg-config
	, libzstd-dev
	, libzstd1
	, librtlsdr0
	, librtlsdr-dev
Standards-Version: 4.7.0
Homepage: https://github.com/adsbfi/readsb
Vcs-Browser: https://salsa.debian.org/alteholz/readsb
Vcs-Git: https://salsa.debian.org/alteholz/readsb.git
Rules-Requires-Root: no

Package: readsb
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, adduser
Description: Mode-S/ADSB/TIS decoder for RTLSDR, BladeRF, Modes-Beast and GNS5894 devices
 As a former fork of dump1090-fa it is using that code base but development
 will continue as a standalone project with new name. Readsb can co-exist on
 the same host system with dump1090-fa, it doesn't use or modify its resources.
 .
 However both programs will not share a receiver device at the same time
 and in parallel.
