=== debian/watch ===
version=4
opts="mode=git, pgpmode=none, pretty=3.14.1630+git%cd.%h" \
https://github.com/adsbfi/readsb \
HEAD debian uupdate
