=== debian/changelog ===
readsb (3.16-2) unstable; urgency=medium

  * fix gcc-15 compilation (Closes: #1097777)
    This was already done in v3.16-1
  * remove -march=native (Closes: #1112633)

 -- Thorsten Alteholz <debian@alteholz.de>  Tue, 02 Sep 2025 23:18:24 +0200

readsb (3.16-1) unstable; urgency=medium

  * New upstream release.
  * debian/watch: switch to new upstream
  * debian/conrol: bump standard to 4.7.2 (no changes)

 -- Thorsten Alteholz <debian@alteholz.de>  Tue, 26 Aug 2025 23:18:24 +0200
