=== debian/control ===
--- 
+++ 
@@ -3,7 +3,6 @@
 Priority: optional
 Maintainer: Thorsten Alteholz <debian@alteholz.de>
 Build-Depends: debhelper-compat(=13)
-	, libusb-1.0-0-dev
 	, libncurses-dev
 	, zlib1g-dev
 	, zlib1g
@@ -11,8 +10,15 @@
 	, libzstd-dev
 	, libzstd1
 	, librtlsdr0
+        , help2man
+	, libusb-1.0-0-dev
 	, librtlsdr-dev
-Standards-Version: 4.7.0
+	, libhackrf-dev
+	, libbladerf-dev
+	, libad9361-dev
+	, libiio-dev
+	, libsoapysdr-dev
+Standards-Version: 4.7.2
 Homepage: https://github.com/adsbfi/readsb
 Vcs-Browser: https://salsa.debian.org/alteholz/readsb
 Vcs-Git: https://salsa.debian.org/alteholz/readsb.git
