=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

ifeq ($(DEB_HOST_ARCH),armhf)
  # Assume a Pi-like target, where using an 8-bit table is a fairly big win over the float path
  CPPFLAGS += -DSC16Q11_TABLE_BITS=8
endif

CONFIG_SWITCH =

# we don't use build profiles here, we use everything
#NOBUILDPROFILE: ifneq ($(filter with_sdrs,$(DEB_BUILD_PROFILES)),)
	CONFIG_SWITCH += 'RTLSDR=yes'
	CONFIG_SWITCH += 'SOAPYSDR=yes'
	CONFIG_SWITCH += 'HACKRF=yes'
	CONFIG_SWITCH += 'BLADERF=yes'
	CONFIG_SWITCH += 'PLUTOSDR=yes'
#NOBUILDPROFILE: endif

#NOBUILDPROFILE: ifneq ($(filter rtlsdr,$(DEB_BUILD_PROFILES)),)
	CONFIG_SWITCH += 'RTLSDR=yes'
#NOBUILDPROFILE: endif

#NOBUILDPROFILE: ifneq ($(filter soapysdr,$(DEB_BUILD_PROFILES)),)
	CONFIG_SWITCH += 'SOAPYSDR=yes'
#NOBUILDPROFILE: endif

#NOBUILDPROFILE: ifneq ($(filter hackrf,$(DEB_BUILD_PROFILES)),)
	CONFIG_SWITCH += 'HACKRF=yes'
#NOBUILDPROFILE: endif

#NOBUILDPROFILE: ifneq ($(filter bladerf,$(DEB_BUILD_PROFILES)),)
	CONFIG_SWITCH += 'BLADERF=yes'
#NOBUILDPROFILE: endif

#NOBUILDPROFILE: ifneq ($(filter plutosdr,$(DEB_BUILD_PROFILES)),)
	CONFIG_SWITCH += 'PLUTOSDR=yes'
#NOBUILDPROFILE: endif

#NOBUILDPROFILE: ifneq ($(filter history,$(DEB_BUILD_PROFILES)),)
	CONFIG_SWITCH += 'HISTORY=yes'
#NOBUILDPROFILE: endif

#NOBUILDPROFILE: ifneq ($(filter native,$(DEB_BUILD_PROFILES)),)
#DO NOT USE THIS:	CONFIG_SWITCH += 'OPTIMIZE=-march=native'
#NOBUILDPROFILE: endif

#NOBUILDPROFILE: ifneq ($(filter biastee,$(DEB_BUILD_PROFILES)),)
        CONFIG_SWITCH += 'HAVE_BIASTEE=yes'
#NOBUILDPROFILE: endif

%:
# systemd no longer in dh>11	dh $@ --with=systemd
	dh $@

override_dh_auto_build:
	make -j4 $(CONFIG_SWITCH)
	help2man -N --no-discard-stderr ./viewadsb > debian/viewadsb.1
	help2man -N --no-discard-stderr ./readsb > debian/readsb.1

override_dh_install:
	dh_install
	install -d debian/readsb/usr/bin
	cp -a readsb debian/readsb/usr/bin/readsb
	#ln -s /usr/bin/readsb debian/readsb/usr/bin/viewadsb
	cp -a readsb debian/readsb/usr/bin/viewadsb

override_dh_installinit:
	dh_installinit --noscripts

override_dh_shlibdeps:
	dh_shlibdeps --dpkg-shlibdeps-params=--ignore-missing-info
