=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/openvlbi-$1\.tar\.gz/ \
  https://github.com/wiedehopf/readsb/tags .*/v?(\d\S+)\.tar\.gz \
	debian uupdate

## old repository
#version=4
#opts="mode=git, pgpmode=none, pretty=3.14.1630+git%cd.%h" \
#https://github.com/adsbfi/readsb \
#HEAD debian uupdate
